#%exefile keen4e.exe 251712 # for K1n9_Duk3's patching utility
%ext ck4
%version 1.4

###########################
# The Usual Junk Required #
###########################

# Load the edited loading screen
%patchfile $1fe47 ck4load.bin

# Load the modified graphics please
#%egahead EGAHEAD.CK4
%patchfile $21080 EGAHEAD.CK4

# Load the maps now
#%maphead maphead.ck4
%patchfile $24830 MAPHEAD.CK4

# Load the tile properties thanks
%patchfile $249C2 keen4.tli

#Disable star wars story screen
%patch $3CBD $04D1W

#Keenwave patch file; Patch sounds Keen 4:
%patchfile $20DF0 AUDIOHED.CK4	#Audio header
%patchfile $354F6 AUDIODCT.CK4	#Audio dictionary

############################
# Miscellaneous            #
############################
# Level Related #
#################

# move the "Wetsuit" string to a different location (overwrites parts of the string for the now unused EGAGRAPH check)
%patch $2F036 "Wetsuit" 0
%patch $808E $01C6w

#Eliminate air-door entry glitch
%patch $2FD5E $0C02W

#Swimming Keen clipping is normal 
%patch $F622 $0001W

#Bridge thickness - Keen 4
%patch $C1F2 $0004W

## Foot ##

#What picks the Foot destination to use (lv 14 done)
%patch $DE36 $7A3AW  $0000W $75

#Foot location 1:
%patch $DE43 $33 #Horizontal location on map in tiles (end location needs to be to the left of start location)
%patch $DE58 $50 #Vertical location on map in tiles

#Location 2: (When exiting POTF)
%patch $DE78 $30 #Horizontal location on map in tiles
%patch $DE8C $17 #Vertical location on map in tiles


#BwB levels: all levels above 17
%patch $60FD $12 $77

#WoW can exit left or right, but keeps worldmap scrolling style
%patch $862B
	$83 $3E $A7EDw $00	#	cmp	mapon, 0
	$74 $1A			#	jz	done
	$8B $44 $22		#	mov	ax, [si+objtype.left]
	$3B $06 $C74Bw		#	cmp	ax, originxmin
	$72 $0B			#	jb	exited
	$A1 $C749w		#	mov	ax, originxmax
	$05 $1400w		#	add	ax, 1400h
	$39 $44 $26		#	cmp	[si+objtype.right], ax
	$76 $06			#	jbe	done
				#exited:
	$C7 $06 $7A70w $0002w	#	mov	playstate, 2
				#done:
	$E9 $FE92w		#	jmp	set_inativate_stuff ;(at cs:1911h)

##################
# Memory Related #
##################

#Free sprites and tiles before loading a level
%patch $61DD
	$74 $0A			#	jz	no_demo
	$C7 $06 $7A6Cw $0002w	#	mov	gamestate_difficulty, 2
	$33 $C0			#	xor	ax, ax
	$EB $03			#	jmp	init_rndt
				#no_demo:
	$B8 $0001w		#	mov	ax, 1
				#init_rndt:
	$50			#	push	ax
	$9A $1D020002rl		#	call	US_InitRndT
	$58			#	pop	ax
	$9A $05C40006rl		#	call	FreeUpMemory
	$90 $90 $90 $90 $90 $90

#Don't free the paddle war sprites (in case loading a game fails)
%patch $5C4B $0081w	# default: $007Cw

################
# Game Related #
################

### Status Window ###

#"Rescued"
%patch $2F49C "RELICS" $00

#Background rectangle
%patch $7E4A $005FW #Horizontal position
%patch $7E42 $0020W #Width

%patch $7E6A $0060W #Horizontal position

#"Drops"
%patch $2F4CB "OSTRUM" $00

#What wins game (3 members)
%patch $6AE4  $7A5EW  $03 $74

######################
# Default highscores #
######################
#Defaults read from
%patch $5A09  $43C4W
%patch $5B58  $43C4W
%patch $5B63  $43C4W
%patch $5B89  $43C4W
%patch $5C06  $43C4W
%patch $194FF $43C4W
%patch $196A9 $43C4W

#Names:
%patch $33234 "Bubbatom         " $00
%patch $33274 "                 " $00
%patch $332B4 "55Aavenue        " $00
%patch $332F4 "Kohntarkosz      " $00
%patch $33334 "Levellass        " $00
%patch $33374 "lemm             " $00
%patch $333B4 "K1n9_Duk3        " $00
%patch $333F4 "Id Software - '91" $00


#########
# Other #
#########

#Terminator text palette:
%patch $2F078 $00 $0E $0E $1E $01 $01 $01 $01     #Dark colors
              $11 $11 $11 $11 $13 $13 $13 $13 $00 #Light colors (and border color)


#Terminator text palette 2, screen moves out:
%patch $2F089 $00 $0E $0E $1E $01 $01 $01 $01     #Dark colors
              $11 $11 $11 $11 $13 $13 $13 $0E $00 #Light colors (and border color)
#########
# Music #
#########

#Where music list is read from:
%patch $8CCD $0396W  #$2F206
%patch $8CA4 $14     #Total number of level entries

#Song values:
#0: Ocflore5          1: Ocflore6
#2: Ocflore7          3: 55Awater
#4: Krobot            5: Ksphere
#6: marsbase          7: nukeduke
#8: Ocflore2          9: Ocflore3
#A: Ocflore4          B: Swords

#This is the music played in each level:
#             VALUE   LEVEL                 MUSIC PLAYED         LEVEL No
%patch $2F206 $0008W  #Map                  (Ocflore2)             0
              $0006W  #Airport	            (marsbase)             1
              $0003W  #Imber Inlet          (55Awater)             2
              $0005W  #Enkri Borough        (Ksphere)              3
              $0007W  #Jungle Crags         (nukeduke)             4
              $0009W  #Frigid Quarry        (Ocflore3)             5
              $0009W  #Enkri Sanctuary      (Ocflore3)             6
              $0001W  #Pelagic Pillars      (Ocflore6)             7
              $0006W  #Ostrum Absorber      (marsbase)             8
              $0009W  #Mt Amnis             (Ocflore3)             9
              $000BW  #Dorsal Obelisk       (swords)              10
              $0002W  #Ancient Observatory  (Ocflore7)            11
              $0000W  #Enkri Shanty         (Ocflore5)            12
              $000AW  #Savannak Temple      (Ocflore4)            13
              $0007W  #Dorsal Battleship    (nukeduke)            14
              $0005W  #Swallowed Spire      (Ksphere)             15
              $000BW  #Evergreen Gate       (swords)              16
              $0003W  #Sunken Sanctum       (55Awater)	          17
              $0000W  #Thicket Steeple      (Ocflore5)            18
              $0004W  #High scores          (robot)               19

#Other music played: (Values here level number in which same music is used.)
%patch $5836 $0000W #Story demo (Not used!)
%patch $9CD7 $000DW #Ending Sequence (Savannak Temple)
%patch $F107 $FFFFW #Talking to Lindsey (none)
%patch $F4CA $0013W #Talking to Ancient (robot)

#Add new music
#Index of first music chunk within audio chunks:
%patch $8CEF $0096W

#Start address of music chunks
#reduce start address by 2x that of "First Audio Entry"
%patch $8C75 $C889W #Clear_music()
%patch $8C83 $C889W #Clear_music()
%patch $8D83 $C889W #StartMusic()
%patch $8C91 $0C    #Total Number of Songs

############################
# Level Names and Entries  #
############################

%patch $1F040 "Ocflore V" 0
%patch $1F050 "Ocflore Airport" 0
%patch $1F060 "Imber Inlet" 0
%patch $1F070 "The Enkri Borough" 0
%patch $1F090 "Jungle Crags" 0
%patch $1F0B0 "Frigid Quarry" 0
%patch $1F0C0 "Enkri Sanctuary" 0
%patch $1F0D0 "Pelagic Pillars" 0
%patch $1F0E0 "Ostrum Absorbor" 0
%patch $1F0F0 "Mount Amnis" 0
%patch $1F100 "Dorsal Obelisk" 0
%patch $1F110 "Ancient Observatory" 0
%patch $1F130 "The Enkri Shanty" 0
%patch $1F150 "Savanak Temple" 0
%patch $1F180 "The Dorsal Battleship" 0
%patch $1F1A0 "Swallowed Spire" 0
%patch $1F1B0 "Evergreen Gate" 0
%patch $1F1C0 "Sunken Sanctum" 0
%patch $1F1D0 "The Thicket Steeple" 0

%patch $1F1F0 "Keen navigates" $0A "planet Ocflore" 0
%patch $1F210 "Keen splashes down at" $0A "the Ocflore Airport" 0
%patch $1F240 "Keen paddles to the" $0A "Imber Inlet" 0
%patch $1F260 "Keen cuts through" $0A "the Enkri Borough" 0
%patch $1F290 "Keen plunges down" $0A "the Jungle Crags" 0
%patch $1F2D0 "Keen cascades into" $0A "the Frigid Quarry" 0
%patch $1F300 "Keen beholds the" $0A "Enkri Sanctuary" 0
%patch $1F330 "Keen dangles on" $0A "Pelagic Pillars" 0
%patch $1F350 "Keen burrows his way to" $0A "the Ostrum Absorbor" 0
%patch $1F380 "Keen conquers" $0A "Mount Amnis" 0
%patch $1F3A0 "Keen filters through " $0A "the Dorsal Obelisk" 0
%patch $1F3D0 "Keen reveals" $0A "the Ancient Observatory" 0
%patch $1F400 "Keen cracks into " $0A "the Enkri Shanty" 0
%patch $1F430 "Keen delves into " $0A "the Savanak Temple" 0
%patch $1F470 "Keen teleports aboard" $0A "the Dorsal Battleship" 0
%patch $1F4B0 "Keen subsides into " $0A "the Swallowed Spire" 0
%patch $1F4E0 "Keen passes through" $0A "the Evergreen Gate" 0
%patch $1F510 "Keen plunges into " $0A "the Sunken Sanctum" 0
%patch $1F540 "Keen catapults up " $0A "the Thicket Steeple" 0


################
#              #
# Text Patches #
#              #
################

#Level end text
%patch $2F16F "You didn't make it past"
%patch $2F187 "Try Again"
%patch $2F191 "  Exit to Ocflore  "

#Wetsuit Text
%patch $30A4B "  This is mine now! "
%patch $30A60 "  Let's swim!   "

#Keen 4 :
%patch $6B6C  $0008W #Width
%patch $6B70  $001AW #Width
%patch $6B81  $0389W #Text called from
%patch $2F1F9 "Just a sec" $00

################################
# Dorsal Relics (Member texts) #
################################

#Council Members text
%patch $30C17 "Keen comes across an"
%patch $30C2C "artifact the old"
%patch $30C3D " Dorsal spoke of. "
%patch $30C50 " An eleborate "
%patch $30C5F "   relic.   "

#Council Members text - Keen's replies
%patch $30A71 "Such an intricate bit"
%patch $30A87 " of gear! "

%patch $30A92 "I wonder how these "
%patch $30AA6 "things work."

%patch $30AB3 " What now?  "

####################
# Dorsal (Lindsey) #
####################

#Hint level 5
%patch $30A25 "   The Dorsal says:   "
%patch $30999 " Keep an eye out for a"
%patch $309B0 "  purple key hidden  "
%patch $309C6 "inside a coral wall."
%patch $309DB "      "
%patch $309FA "Alright, I'll "
%patch $30A09 "     keep my eyes"
%patch $30A1A " peeled! "

#Hint level 7
%patch $30A25 "   The Dorsal says:   "
%patch $3094C " It's dangerous to  "
%patch $30961 "stumble in teleporters "
%patch $30979 "  at the Swallowed   "
%patch $3098F " Spire. "
%patch $309E3 "   Don't you worry!   "

#########################
#                       #
# ENEMY RELATED PATCHES #
#                       #
#########################

##############
# Schoolfish #
##############

# fullclip schoolfish hitbox
%patch $A7B2 $0180w     # width  (default: $0100w = 16 pixels)
%patch $A7B7 $0100w     # height (default: $0080w =  8 pixles)

########
# Mine #
########

#Mine explodes
#patch $3271E $01B9W $01B9W
#patch $32728 $001EW        #Animation speed
#patch $3273C $01BAW $01BAW
#patch $32746 $00EEW        #Animation speed (Vanishes) (Made longer)

#########
# Cloud #
#########

%patch $10A36 $0014W #Speed when moving

#Zap Keen
%patch $31896 $01F4W $01F4W
%patch $318A0 $0001W        #Pause while lightening strikes

############
# Dopefish #
############

#Seek Keen vertically - reversed
%patch $12177 $FFFFW
%patch $1218B $0001W

################
# Mad Mushroom #
################

#Number of low\high bounces
%patch $FF90 $0002W #Xth jump is tall
%patch $FF97 $0000W #Reset value

%patch $FFBB $FFE8W #Small
%patch $FF9C $FFB6W #High
%patch $FF7C $0000W #Bounce down from ceiling

##################
# Treasure Eater #
##################

#Treasure Eater foreground values
%patch $11A4C $0001W #Treasure Eater

###########
# Bounder #
###########

%patch $111BC $FFD8W #Bounder's vertical jump height
%patch $111FE $0010W #Bounder's jump length (With Keen riding)

#Bounders chase Keen
%patch $111C2 $90 $90

#Bounder collision: Lethal, shootable
%patch $11138 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09     #Check for Keen (Type 2)
              $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $0E $B8         #If Keen, kill him; check for shot (Type 3)
              $2F8AW  $50 $57 $56 $9A $09DC1695RL     $83 $C4 $06 $5F $5E $5D $CB #If shot, become $2F8AW


###############
# Poison Slug #
###############

#Crawling
%patch $30E8E $0080W $0000W #Speed 1
%patch $30EAC $0080W $0000W #Speed 2

#Foreground
%patch $FD9C  $0000W #Poison slug

#Slug collision produces only one type of slug
%patch $FE6A $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09 #Check for Keen (Type 2)
         $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $1F $B8     #If Keen, kill him; check for shot (Type 3)
         $206CW  $50 $57 $56 $9A $09DC1695RL     $83 $C4 $06 $C7 $44 $18     #If shot, become $206C
         $FFE8W  $8B $44 $0E $D1 $E0 $D1 $E0 $D1 $E0 $89 $44 $16 $5F $5E $5D #Jump into the air $FFE8
             $CB

#Swap pooping slug (facing left) and unused stunned slug sprite
%patch $30F36 319w 319w

#Slug doesn't load the unused stunned sprite
%patch $30730 323w

##########
# Sprite #
##########

#Sprite's shots have 3 frames
%patch $126A6 $3836W
%patch $326FE $3836W

#Sprite uses new collision
%patch $32624 $2EE70146RL
%patch $32642 $2EE70146RL
%patch $32660 $2EE70146RL
%patch $3267E $2EE70146RL

#Stunned sprite action (1st frame of old bullet)
%patch $32688 $01B4W $01B4W $0002W $0000W $0000W $00F0W $0000W $0000W
              $09DC16C9RL   $00000000L    $09DC176ERL   $3818W

#New Sprite collision, react to Keen's shot, kill Keen
%patch $2EFB6 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09
              $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $18 $C7 $44
              $16 $0000W  $C7 $44 $06 $0001W  $B8 $3818W  $50 $57 $56 $9A $09DC1695RL
                          $83 $C4 $06 $5F $5E $5D $CB

###########
# SkyPest #
###########

#Skypest don't land but slide along ground
%patch $10797 $2E

#Skypest can be stunned:
#New collision for Skypest, stunnable =$037D055ERL
%patch $3D2E $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09 #Check for Keen (Type 2)
             $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $1F $B8     #If Keen, kill him; check for shot (Type 3)
             $24C2W  $50 $57 $56 $9A $09DC1695RL     $83 $C4 $06 $C7 $44 $18     #If shot, become $24C2W
             $FFE8W  $8B $44 $0E $D1 $E0 $D1 $E0 $D1 $E0 $89 $44 $16 $5F $5E $5D #Jump into the air $FFE8
             $CB

#Skypests use new collision
%patch $3130A $037D055ERL #Flying Skypest
%patch $31328 $037D055ERL #Flying Skypest

#Stunned skypest sprite has been moved into the slot of the first licking
#skypest sprite (447 instead of 456)

#Stunned Skypests act properly
%patch $31332 447W 447W $0002W $0000W $0000W $0000W $0000W $0000W
              $09DC16C9RL   $00000000L    $09DC1913RL   $0000W

#Skypest doesn't load the sitting/licking sprites
%patch $30748 447w

#############
# Inch Worm #
#############

#Inchworm Speed
%patch $31D16 $0100W $0000W #Speed 1
%patch $31D34 $0100W $0000W #Speed 2

#Keen appears in front of Inchworm
%patch $10ED0 $0000W #Inchworm

#Inchworm avoids keen (behavior code)
%patch $10F70 $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $8B $1E $D6 $A7 $3B $47
              $0A $76 $08 $C7 $44 $0E $0001W  $5E $5D $CB $C7 $44 $0E $FFFFW
              $5E $5D $CB


##############NEW LASS STUFF############

#Slave Inchworm and Arachnut caches
%patch $EAEA $010AW

#Inchworms use new collision codes
%patch $31D1E $037D0526RL
%patch $31D3C $108007B5RL

#Disable EGAGRAPH check in Keen 4 (Frees 389 bytes at $3CF6)
%patch $3CE5 $90 $90

#Inchworm collision: React to other worms by converting other worm =$037D0526RL
%patch $3CF6 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $10 $75 $09
             $56 $9A $037D0543RL     $83 $C4 $02 $5F $5E $5D $CB

#Convert colliding worm =$037D0543RL
%patch $3D13 $55 $8B $EC $56 $8B $76 $06 $C7 $04 $0022W  $B8 $011FW  $50 $56
             $9A $09DC120ARL     $83 $C4 $04 $5E $5D $CB

#Converted worm, returns to normal if left =$011FW
%patch $2EF8F $0000W $0000W $0000W $0000W $0000W $0008W $0000W $0000W
              $10800793RL   $00000000L    $09DC176ERL   $2E9AW

#Clipped InchCol: React to converted worms =$108007B5RL
%patch $10FB5 $55 $8B $EC $56 $57 $8B $76 $06 $8B $5E $08 $83 $3F $22 $74 $03
              $E9 $010DW  $B8 $002DW  $50 $9A $187409F1RL     $83 $C4         #Play sound $2D
              $02 $81 $6C $0C $0000W  $C7 $04 $000AW  $B8 $2378W  $50 $56 $9A #Turn worm into Arachnut
              $09DC120ARL     $83 $C4 $04 $B8 $0001W  $50 $9A $06BD1E11RL
              $83 $C4 $02 $8B $44 $0A $2D $0080W  $8B $1E $D8 $A7 $89 $47 $0A #Up smoke
              $8B $44 $0C $05 $0100W  $89 $47 $0C $C7 $47 $20 $0003W  $B8 $2E22W
                  $50 $53 $9A $09DC118CRL     $83 $C4 $04 $B8 $0001W  $50 $9A
              $06BD1E11RL     $83 $C4 $02 $8B $44 $0A $05 $0100W  $8B $1E $D8 #Left smoke
              $A7 $89 $47 $0A $8B $44 $0C $05 $0180W  $89 $47 $0C $C7 $47 $20
              $0003W  $B8 $2E22W  $50 $53 $9A $09DC118CRL     $83 $C4 $04 $B8
              $0001W  $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $44 $0A $05 $0280W
%patch $11064     $8B $1E $D8 $A7 $89 $47 $0A $8B $44 $0C $05 $0100W  $89 $47 #Right smoke
              $0C $C7 $47 $20 $0003W  $B8 $2E22W  $50 $53 $9A $09DC118CRL     
              $83 $C4 $04 $B8 $0001W  $50 $9A $06BD1E11RL     $83 $C4 $02 $8B
              $44 $0A $8B $1E $D8 $A7 $89 $47 $0A $8B $44 $0C $2D $0080W  $89 #Down smoke
              $47 $0C $C7 $47 $20 $0003W  $B8 $2E22W  $50 $53 $9A $09DC118CRL
                  $83 $C4 $04 $8B $1E $D6 $A7 $8B $7F $48 $EB $11 $83 $3D $22 #Remove converted worm
              $75 $09 $57 $9A $06BD1E8BRL     $83 $C4 $02 $8B $7D $48 $0B $FF
              $75 $EB $5F $5E $5D $CB

#Converted worm reverts back to normal worm if left without removal =$10800793RL
%patch $10F93 $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $C7 $04 $0010W  $5E $5D $CB

#Special squish collision for Inchworms = $0B8015CDRL
%patch $CDCD $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $8B $04 $3D $0010W  #Worm,
             $74 $05 $3D $0022W  $75 $21 $B8 $0016W  $50 $9A $187409F1RL
             $83 $C4 $02 $C7 $04 $0001W  $B8 $24E0W  $50 $56 $9A $09DC120ARL
                 $83 $C4 $04 $5F $5E $5D $CB $E9 $FEAEW

#Keen bouncing uses squishing collision
%patch $2FF90 $0B8015CDRL
%patch $2FFAE $0B8015CDRL
%patch $2FFCC $0B8015CDRL

#Squished Inchworm sprite has been moved into the slot of the foot sprite
#to make sure the sprite is loaded along with the other inchworm sprites

#Squished Inchworm state at dseg:24E0
#(replaces first state of laded skypest, which isn't used anywhere else)
%patch $31350
	337w 337w 0w 0w 0w 30000w 0w 0w 0l 0l $09DC176Erl $24E0w

#Mooning icon doesn't load any sprites
%patch $EF19 $050Dw

########
# Foot #
########

#Foot now uses 2nd mooning sprite slot
%patch $31D64 520w 520w

#Foot sprite is never drawn
%patch $31D7C $0L

#Foot doesn't load any sprites (we only need the hitbox)
%patch $EA9A $E9 $0360w

#################
# Oracle Member #
#################

#Oracle Member doesn't move and is never drawn
%patch $30E28
	356w 356w 0w 0w 0w 30000w 0w 0w 0l 0l 0l $1FB8w

#Oracle Member doesn't load any sprites
%patch $E9E0 $E9 $041Aw

###########
# Lindsey #
###########

#Lindsey doesn't move and is never drawn
%patch $3275A
	329w 329w 0w 0w 0w 30000w 0w 0w 0l 0l 0l $38EAw

#Lindsey doesn't load any sprites
%patch $EA1E $E9 $03DCw

########
# Lick #
########

#Lick Foreground variable
%patch $112E6 $0000W

#Lick is deadly all the time, new collision
%patch $11423 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09 #Check for Keen (Type 2)
              $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $12
              $B8 $312EW  $50 $57 $56 $9A $09DC1695RL     $83 $C4 $06 $83 $6C
              $18 $10 $5F $5E $5D $CB

#Lick blocks shots but is not stunnable
%patch $1140D $57 $9A $0D8F0D43RL     $83 $C4 $02 $5F $5E $5D $CB

#Bouncing Lick uses this too
%patch $31E4A $10800C23RL #Lick bouncing
%patch $31E68 $10800C23RL #Lick bouncing
%patch $31E86 $10800C23RL #Lick bouncing
%patch $31EA4 $10800C23RL #Lick bouncing

#Lick movement code less flame checks (value FFB0 is jump height)
%patch $11342 $55 $8B $EC $83 $EC $02 $56 $57 $8B $76 $06 $8B $44 $0A $8B $1E #Check Keen's location
              $D6 $A7 $3B $47 $0A $76 $07 $C7 $44 $0E $FFFFW  $EB $05 $C7 $44 #Change H direction to follow him
              $0E $0001W  $8B $44 $0E $B1 $05 $D3 $E0 $89 $44 $16 $C7 $44 $18
              $FFC8W  $5F $5E $8B $E5 $5D $CB                                 #Large jump 

#Lick stunned sprite replaces first fire-breathing sprite
%patch $31F9E 477w 477w
%patch $31FBC 477w 477w

#Lick doesn't load the fire-breathing sprites
%patch $3074C 477w


###########
# Mimrock #
###########

#Mimrock foreground variable
%patch $11E85 $0000W

#Mimrock has the mad mushroom collision while Pouncing 
%patch $32390 $0FA804BERL 
%patch $323AE $0FA804BERL 
%patch $323CC $0FA804BERL 
%patch $323EA $0FA804BERL #bouncing on the ground

#Attack jump
%patch $11F65 $FFE0W #Jump height
%patch $11F5B $0014W #Jump length

#############
# Berkeloid #
#############

#Berkeloid shots fly horizontally
%patch $31B58 $00000000L
%patch $31B76 $00000000L
%patch $31B4C $0001W
%patch $31B6A $0001W
%patch $31B54 $0040W #Speed 1
%patch $31B72 $0040W #Speed 2

#Berkeloid flames smash on walls as well as floors
%patch $10D5E $55 $8B $EC $56 $8B $76 $06 $83 $7C $38 $00 $75 $0C $83 $7C $3C
              $00 $75 $06 $83 $7C $36 $00 $74 $19 $B8 $0028W
                  $50 $9A $187409F1RL     $83 $C4 $02 $B8 $2D14W  $50 $56 $9A
              $09DC120ARL     $83 $C4 $04 $FF $74 $20 $33 $C0 $50 $FF $74 $1E
              $FF $74 $0C $FF $74 $0A $8B $C6 $05 $46 $00 $50 $9A $16541641RL
              $83 $C4 $0C $5E $5D $CB

#############
# Blue Bird #
#############

#Walking birds (easy, medium, hard) are separate from flying birds
#Spawn points
%patch $EECB $1A84W #'I Keen' (Easy bird)
%patch $EECD $1A7DW #'Mom' (Normal bird)
%patch $EECF $1A76W #'Dad' (Hard bird)

#Initiation code at + $1A76
%patch $10366 $83 $3E $7A6CW  $03 $7C $19 $83 $3E $7A6CW  $02 $7C $12 $FF $76
              $FC $57 $9A $0FA808A1RL     $83 $C4 $04 $C7 $06 $5F $CB $0001W
              $E9 $EA74W

#Flying bird spawn code = $0FA808A1RL
%patch $10321 $55 $8B $EC $B8 $01 $00 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B
              $1E $D8 $A7 $C7 $07 $001BW  $C7 $47 $02 $0001W  $C7 $47 $20 $0002W
                  $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0
              $05 $FF1FW  $89 $47 $0C $B8 $224CW  $50 $53 $9A $09DC118CRL
              $83 $C4 $04 $5D $CB

#Stop the flying birds becoming walking birds:
%patch $103D0 $EB #Bird doesn't land when Keen is standing on ground level with it
%patch $1048B $EB #Don't land when Keen below it and Bird near ground

#Stop the walking birds flying or going to stunned bird and change walking speed
%patch $31026 $0173W $016FW $0000W $0000W $0001W $0078W $0080W $0000W #Waiting bird
              $00000000L    $0FA804BERL   $09DC1795RL   $21F2W
%patch $31044 $0173W $016FW $0000W $0000W $0001W $0007W $0060W $0060W #Walking birds
              $00000000L    $0FA804BERL   $09DC1795RL   $21F2W
%patch $31062 $0174W $0170W $0000W $0000W $0001W $0007W $0060W $0060W
              $00000000L    $0FA804BERL   $09DC1795RL   $2210W
%patch $31080 $0175W $0171W $0000W $0000W $0001W $0007W $0060W $0060W
              $00000000L    $0FA804BERL   $09DC1795RL   $222EW
%patch $3109E $0176W $0172W $0000W $0000W $0001W $0007W $0060W $0060W
              $10800770RL   $0FA804BERL   $09DC1795RL   $21D4W

#Eggs hatch to flying birds
%patch $10135 $224CW

#Stunned birds unstun to flying
%patch $311E6 $224CW

#Fix walking spawn height (Stop it floating in air)
%patch $1006A $FF1FW

#Bird stunned
%patch $31152 $017BW $017BW $0002W $0000W $0000W $0000W $0000W $0000W
              $09DC16C9RL   $00000000L    $09DC1913RL   $0000W

#Foreground for egg
%patch $FFFB  $0001W #Egg

#Flying Speed
%patch $1027D $0020W #Left\right ACCELERATION when flying
%patch $10299 $0010W #Up ACCELERATION when flying
%patch $102AD $0010W #Down ACCELERATION when flying

###########
#Stun star#
###########

#Skypest: type 4
%patch $B7EE $19A8W

#Type 4 position (used for Bounder in Keen 4)
%patch $B768 $C7 $46 $FE $0040W  $BF $FF80W $EB $1C 


#Lick: type 5
%patch $B7FC $19B2W

#Type 5 position (shared with Wormouth!)
%patch $B772 $C7 $46 $FE $0040W  $BF $FEA2W  $EB $12 


#Slug: (overrides unused Inchworm type from Keen 4)
%patch $B7E2 $19C1w
%patch $B784 $FF80w


#Bounder: (overrides Treasure Eater type for X and uses old Slug type for Y)
%patch $B7F6 $19A1w
%patch $B764 $00C0w
%patch $B767 $23


#Compress normal K collision for space (Frees $CDCD-CE31)
%patch $CCA9 $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $8B $04 $3D $0011W  #Foot
             $75 $06 $C7 $06 $7A70W  $0007W  $3D $0006W  $75 $38 $83 $7D $36 #Council
             $00 $74 $2E $83 $3E $A7EDW  $0E $75 $15 $9A $0E8F07D9RL     $9A
             $16540D59RL     $56 $9A $06BD1E8BRL     $83 $C4 $02 $EB $12 $B8
             $001FW  $50 $9A $187409F1RL     $83 $C4 $02 $C7 $06 $7A70W  $0003W
                 $5F $5E $5D $CB $3D $000FW  $75 $0F $33 $C0 $50 $56 $57 $9A #Bounders
             $09DC0DA0RL     $83 $C4 $06 $EB $E8 $3D $0021W  $75 $06 $83 $7C #Platforms, stunned
             $44 $0F $74 $05 $3D $0014W  $75 $13 $83 $3E $7A6EW  $00 $75 $D1
             $56 $57 $9A $09DC0D33RL     $83 $C4 $04 $EB $C5 $3D $0018W  $75 #Lindsey
             $15 $9A $0E8F0645RL     $56 $9A $06BD1E8BRL     $83 $C4 $02 $9A #Items
             $16540D59RL     $EB $AB $3D $0004W  $75 $A6
%patch $CD54                                                 $8B $5C
             $3E $D1 $E3 $FF $B7 $13DCW  $9A $187409F1RL     $83 $C4 $02 $C7
             $04 $0001W  $C7 $44 $20 $0003W  $8B $5C $3E $D1 $E3 $8B $87 $140CW
                 $89 $44 $1E $8B $5C $3E $D1 $E3 $FF $B7 $13F4W  $9A $06BD1EF2RL
                 $83 $C4 $02 $83 $7C $3E $04 $7D $0B $8B $5C $3E $D1 $E3
             $FF $87 $7A60W  $EB $20 $83 $7C $3E $0A $75 $06 $FF $06 $7A6AW
             $EB $14 $83 $7C $3E $0B $75 $0E $8B $1E $7A6CW  $D1 $E3 $8B $87
             $13D4W  $01 $06 $7A58W  $B8 $1F28W  $50 $56 $9A $09DC120ARL   
             $83 $C4 $04 $5F $5E $5D $CB

#############################################
# K1n9_Duk3's Customized Screen Update Code #
#############################################

#replace the v1.4 delay code with my custom VW_SetScreen code
#(my VW_SetScreen is bigger than the one in v1.4)
%patch $1E7F9
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$BA $03DAw		#	mov	dx, 3DAh
	$FA			#	cli
				#@l1:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$74 $FB			#	jz	@l1
				#@l2:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$75 $FB			#	jnz	@l2
	$8B $4E $06		#	mov	cx, [bp+arg_start]
	$BA $03D4w		#	mov	dx, 3D4h
	$B0 $0C			#	mov	al, 0Ch
	$EE			#	out	dx, al
	$42			#	inc	dx
	$8A $C5			#	mov	al, ch
	$EE			#	out	dx, al
	$4A			#	dec	dx
	$B0 $0D			#	mov	al, 0Dh
	$EE			#	out	dx, al
	$8A $C1			#	mov	al, cl
	$42			#	inc	dx
	$EE			#	out	dx, al
	$F7 $06 $7A14w $0001w	#	test	fixjerky, 1
	$74 $03			#	jz	@l3
	$E8 $0053w		#	call	WaitVBL
				#@l3:
	$F7 $06 $7ADEw $0001w	#	test	nopan, 1
	$75 $0C			#	jnz	l4
	$BA $03C0w		#	mov	dx, 3C0h
	$B0 $33			#	mov	al, 33h
	$EE			#	out	dx, al
	$EB $00			#	jmp	$
	$8A $46 $08		#	mov	al, [bp+arg_pan]
	$EE			#	out	dx, al
				#@l4:
	$F7 $06 $7A14w $0001w	#	test	fixjerky, 1
	$75 $03			#	jnz	@l5
	$E8 $0034w		#	call	WaitVBL
				#@l5:
	$FB			#	sti
	$5D			#	pop	bp
	$CB			#	retf

#replace the start of VW_SetScreen with a jump into my new code (see above):
%patch $1E87A
	$E9 $FF7Cw

#and overwrite the rest of the old VW_SetScreen code with my WaitVBL code:
	$8B $1E $A53Dw		#	mov	bx, word ptr TimeCount
	$BA $03DAw		#	mov	dx, 3DAh
				#@wait:	
	$FB			#	sti
	$EB $00			#	jmp	short $
	$FA			#	cli
	$EC			#	in	al, dx
	$A8 $08			#	test	al, 8
	$75 $0A			#	jnz	@done
	$A1 $A53Dw		#	mov	ax, word ptr TimeCount
	$2B $C3			#	sub	ax, bx
	$3D $0001w		#	cmp	ax, 1
	$76 $ED			#	jbe	@wait
				#@done:
	$C3			#	retn

#########################################
# K1n9_Duk3's Palette Modification Code #
#########################################

# Don't try to use this without my customized screen update code!
#
# This code replaces the unused parts of the old VW_SetScreen delay routine
# with code to update the VGA palette registers as specified in the palette
# data block defined below.

# my VW_SetScreenMode replacement (44 bytes):
%patch $1E84C
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$FF $76 $06		#	push	[bp+arg_0]
	$9A $1D0600ACrl		#	call	VW_SetScreenMode
	$58			#	pop	ax
	$83 $3E $E812w $05	#	cmp	videocard, 5
	$75 23			#	jnz	@done
	$56			#	push	si
	$BE $0180w		#	mov	si, offset vgapal
	$B9 5w			#	mov	cx, ...
	$BA $03C8w		#	mov	dx, 3C8h
				#@palloop:
	$AC			#	lodsb
	$EE			#	out	dx, al
	$42			#	inc	dx
	$AC			#	lodsb
	$EE			#	out	dx, al
	$AC			#	lodsb
	$EE			#	out	dx, al
	$AC			#	lodsb
	$EE			#	out	dx, al
	$4A			#	dec	dx
	$E2 $F4			#	loop	@palloop
	$5E			#	pop	si
				#@done:
	$5D			#	pop	bp
	$CB			#	retf

# call my replacement instead of the original VW_SetScreenMode
%patch $39DB $1E0A07ACrl	# at startup
%patch $7A69 $1E0A07ACrl	# after the [F9] fake DOS prompt

# the VGA palette data we want to use in Ocflore
%patch $2EFF0
	$02 $00 $26 $00		# make dark green slightly darker
	$03 $3F $20 $10		# turn dark cyan into light brown/orange
	$0E $2A $2A $15		# special dark yellow color for the intro
	$11 $00 $15 $2A		# special dark blue
	$13 $00 $3F $2A		# special light cyan

# The VGA palette data contains multiple entries, 4 bytes each. The first byte
# is the EGA color index (usually between $00 and $1F). The remaining three
# bytes are 6-bit RGB values that define the color. RGB means the first value
# is the Red part, the second is Green and the third is Blue. Most modern tools
# use 8-bit color values, though. Divide the 8-bit value by 4 to get the the
# 6-bit value.
#
# For example, the 6-bit RGB values $3F $20 $10 represent the 8-bit values
# $FF $82 $41 or FF8241 combined. 

# The palette replaces parts of the text string normally used by the EGAGRAPH
# check. The current location works fine for Ocflore, but you might have to
# move it around for other mods.
#
# If you modify this code, make sure to update the main code with the correct
# offset (the "offset vgapal" line) and the number of color entries to process
# (the "mov cx, ..." line)!

#------------------------------------------------------------------------------

##############################
# Load Audio Chunks Directly #
##############################

# This patch forces the game to load the audio data directly from the file into
# the final buffer without doing any Huffman decompression. This requires the
# AUDIO.CK4 file to be compressed with a "dummy" Huffman dictionary (which is
# the case in Operation Ocflore).
#
# Without this code, the game would load the "compressed" data into a temporary
# buffer and then decompress it into the final buffer. That means the memory
# requirements for music are more than TWICE(!) the size of the IMF song.

%patch $13466
	$33 $C0			#	xor	ax, ax
	$50			#	push	ax
	$FF $76	$FE		#	push	bp+var_2
	$FF $76 $FC		#	push	bp+var_4
	$FF $36 $CB9Dw		#	push	audiohandle
	$9A $00001BC9rl		#	call	_lseek
	$83 $C4 $08		#	add	sp, 8
	$B8 $0004w		#	mov	ax, 4
	$50			#	push	ax
	$B8 $CB95w		#	mov	ax, offset chunkexplen
	$50			#	push	ax
	$FF $36 $CB9Dw		#	push	audiohandle
	$9A $00001F10rl		#	call	_read
	$83 $C4 $06		#	add	sp, 6
	$FF $36 $CB97w		#	push	word ptr chunkexplen+2
	$FF $36 $CB95w		#	push	word ptr chunkexplen
	$8B $C6			#	mov	ax, si
	$D1 $E0			#	shl	ax, 1
	$05 $C75Dw		#	add	ax, offset audiosegs
	$50			#	push	ax
	$9A $155E0712rl		#	call	MM_GetPtr
	$83 $C4 $06		#	add	sp, 6
	$83 $3E $A7EFw $00	#	cmp	mmerror, 0
	$75 $1E			#	jnz	done
	$FF $36 $CB97w		#	push	word ptr chunkexplen+2
	$FF $36 $CB95w		#	push	word ptr chunkexplen
	$8B $DE			#	mov	bx, si
	$D1 $E3			#	shl	bx, 1
	$FF $B7 $C75Dw		#	push	audiosegs[bx]
	$33 $C0			#	xor	ax, ax
	$50			#	push	ax
	$FF $36 $CB9Dw		#	push	audiohandle
	$0E			#	push	cs
	$E8 $F68Bw		#	call	near ptr CA_FarRead
	$83 $C4 $0A		#	add	sp, 10
				#done:
	$5E			#	pop	si
	$8B $E5			#	mov	sp, bp
	$5D			#	pop	bp
	$CB			#	retf

##################################################
# Stop enemies from getting stuck at slope edges #
##################################################

#generic WalkReact (used by Arachnut, Inchworm and Mimrock)
%patch $B55C
	$83 $7C $0E $01		#	cmp	[si+xdir], 1
	$75 $06			#	jnz	l1
	$83 $7C $3C $00		#	cmp	[si+hitwest], 0
	$75 $12			#	jnz	turn
				#l1:
	$83 $7C $0E $FF		#	cmp	[si+xdir], -1
	$75 $06			#	jnz	l2
	$83 $7C $38 $00		#	cmp	[si+hiteast], 0
	$75 $06			#	jnz	turn
				#l2:
	$83 $7C $36 $00		#	cmp	[si+hitnorth], 0
	$75 $27			#	jnz	draw
				#turn:
	$8B $44 $12		#	mov	ax, [si+xmove]
	$29 $44 $0A		#	sub	[si+x], ax
	$8B $44 $14		#	mov	ax, [si+ymove]
	$29 $44 $0C		#	sub	[si+y], ax
	$F7 $5C $0E		#	neg	[si+objtype.xdir]
	$9A $1D02002Arl		#	call	US_RndT
	$B1 $05			#	mov	cl, 5
	$D3 $F8			#	sar	ax, cl
	$89 $44 $08		#	mov	[si+nothink], ax
	$FF $74 $1C		#	push	[si+state]
	$56			#	push	si
	$9A $09DC120Arl		#	call	ChangeState
	$83 $C4 $04		#	add	sp, 4
				#draw:
	$FF $74 $20		#	push	[si+priority]
	$33 $C0			#	xor	ax, ax
	$50			#	push	ax
	$FF $74 $1E		#	push	[si+shapenum]
	$FF $74 $0C		#	push	[si+y]
	$FF $74 $0A		#	push	[si+x]
	$8B $C6			#	mov	ax, si
	$05 $0046w		#	add	ax, objtype.sprite
	$50			#	push	ax
	$9A $16541641rl		#	call	RF_PlaceSprite
	$83 $C4 $0C		#	add	sp, 0Ch
	$5E			#	pop	si
	$5D			#	pop	bp
	$CB			#	retf

#"safe" WalkRect (don't step onto deadly tiles or pole holes, used by slugs)
%patch $B60E
	$83 $7C $0E $01		#	cmp	[si+xdir], 1
	$75 $06			#	jnz	l1
	$83 $7C $3C $00		#	cmp	[si+hitwest], 0
	$75 $19			#	jnz	turn
				#l1:
	$83 $7C $0E $FF		#	cmp	[si+xdir], -1
	$75 $06			#	jnz	l2
	$83 $7C $38 $00		#	cmp	[si+hiteast], 0
	$75 $0D			#	jnz	turn
				#l2:
	$83 $7C $36 $00		#	cmp	[si+hitnorth], 0
	$74 $07			#	jz	turn
	$F7 $44 $36 $FFF8w	#	test	[si+hitnorth], not 7	
	$74 $27			#	jz	draw
				#turn:
	$8B $44 $12		#	mov	ax, [si+xmove]
	$29 $44 $0A		#	sub	[si+x], ax
	$8B $44 $14		#	mov	ax, [si+ymove]
	$29 $44 $0C		#	sub	[si+y], ax
	$F7 $5C $0E		#	neg	[si+objtype.xdir]
	$9A $1D02002Arl		#	call	US_RndT
	$B1 $05			#	mov	cl, 5
	$D3 $F8			#	sar	ax, cl
	$89 $44 $08		#	mov	[si+nothink], ax
	$FF $74 $1C		#	push	[si+state]
	$56			#	push	si
	$9A $09DC120Arl		#	call	ChangeState
	$83 $C4 $04		#	add	sp, 4
				#draw:
	$FF $74 $20		#	push	[si+priority]
	$33 $C0			#	xor	ax, ax
	$50			#	push	ax
	$FF $74 $1E		#	push	[si+shapenum]
	$FF $74 $0C		#	push	[si+y]
	$FF $74 $0A		#	push	[si+x]
	$8B $C6			#	mov	ax, si
	$05 $0046w		#	add	ax, objtype.sprite
	$50			#	push	ax
	$9A $16541641rl		#	call	RF_PlaceSprite
	$83 $C4 $0C		#	add	sp, 0Ch
	$5E			#	pop	si
	$5D			#	pop	bp
	$CB			#	retf

#BerkeloidWalkReact
%patch $10E17
	$83 $7C $0E $01		#	cmp	[si+xdir], 1
	$75 $06			#	jnz	l1
	$83 $7C $3C $00		#	cmp	[si+hitwest], 0
	$75 $12			#	jnz	turn
				#l1:
	$83 $7C $0E $FF		#	cmp	[si+xdir], -1
	$75 $06			#	jnz	l2
	$83 $7C $38 $00		#	cmp	[si+hiteast], 0
	$75 $06			#	jnz	turn
				#l2:
	$83 $7C $36 $00		#	cmp	[si+hitnorth], 0
	$75 $27			#	jnz	draw
				#turn:
	$8B $44 $12		#	mov	ax, [si+xmove]
	$29 $44 $0A		#	sub	[si+x], ax
	$8B $44 $14		#	mov	ax, [si+ymove]
	$29 $44 $0C		#	sub	[si+y], ax
	$F7 $5C $0E		#	neg	[si+objtype.xdir]
	$9A $1D02002Arl		#	call	US_RndT
	$B1 $05			#	mov	cl, 5
	$D3 $F8			#	sar	ax, cl
	$89 $44 $08		#	mov	[si+nothink], ax
	$FF $74 $1C		#	push	[si+state]
	$56			#	push	si
	$9A $09DC120Arl		#	call	ChangeState
	$83 $C4 $04		#	add	sp, 4
				#draw:
	$E9 $FF5Dw		#	jmp	cs:05BC

%end